#include <wx/wxprec.h>
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

#include <vector>

using namespace std;

/* 95% copy&paste from stackoverflow, copyright Michael, unixman83, licence unknown */

void ParseCSV(const wxString& csvSource, vector<vector<wxString> >& lines)
{
	bool inQuote(false);
	bool lastQuote(false);
	bool newLine(false);
	wxString field;
	lines.clear();
	vector<wxString> line;

	wxString::const_iterator aChar = csvSource.begin();
	while (aChar != csvSource.end())
	{
	  switch ((int)*aChar)
	  {
	  case '"':
	     newLine = false;
	     inQuote = !inQuote;
	     if(lastQuote) field += *aChar;
	     break;

	  case ',':
	     newLine = false;
	     if (inQuote == true)
	     {
	        field += *aChar;
	     }
	     else
	     {
	        line.push_back(field);
	        field.clear();
	     }
	     break;

	  case '\n':
	  case '\r':
	     if (inQuote == true)
	     {
	        field += *aChar;
	     }
	     else
	     {
	        if (newLine == false)
	        {
	           line.push_back(field);
	           lines.push_back(line);
	           field.clear();
	           line.clear();
	           newLine = true;
	        }
	     }
	     break;

	  default:
	     newLine = false;
	     field += (*aChar);
	     break;
	  }
      lastQuote = ((!lastQuote) && *aChar=='"');
	  aChar++;
	}

	if (field.size())
	  line.push_back(field);

	if (line.size())
	  lines.push_back(line);
}